package org.xdoclet.plugin.beaninfo.qtags;

/**
 * Used to specify class related information of JavaBean BeanInfo
 * @qtags.location class
 */
public interface JavabeanClassTag extends com.thoughtworks.qdox.model.DocletTag {
    /**
     * Name of the JavaBean (typically the unqualified className)
     *
     * @qtags.required
     */
    String getName_();

    /**
     * The name displayed for the JavaBean
     */
    String getDisplayName();

    /**
     * A short description about the JavaBean
     */
    String getShortDescription();

    /**
     * Is the JavaBean used in expert mode ?
     *
     * @qtags.allowed-value true
     * @qtags.allowed-value false
     */
    boolean isExpert();

    /**
     * Is the JavaBean hidden ?
     *
     * @qtags.allowed-value true
     * @qtags.allowed-value false
     */
    boolean isHidden();

    /**
     * Is the JavaBean preferred ?
     *
     * @qtags.allowed-value true
     * @qtags.allowed-value false
     */
    boolean isPreferred();

    /**
     * Fully qualified class name of the JavaBean customizer
     */
    String getCustomizer();

    /**
     * Fully qualified class name of the JavaBean ancestor used to stop introspection for additionnal informations
     */
    String getStopClass();

}
