package org.xdoclet.plugin.beaninfo.qtags;

/**
 * Defines the JavaBean method found by introspection
 */
public interface JavabeanMethodTag extends com.thoughtworks.qdox.model.DocletTag {
    /**
     * Name of the method
     *
     */
    String getName_();

    /**
     * The name displayed for the method
     *
     */
    String getDisplayName();

    /**
     * A short description about the method
     *
     */
    String getShortDescription();

    /**
     * Is the method used in expert mode ?
     *
     * @qtags.allowed-value true
     * @qtags.allowed-value false
     */
    boolean isExpert();

    /**
     * Is the method hidden ?
     *
     * @qtags.allowed-value true
     * @qtags.allowed-value false
     */
    boolean isHidden();

    /**
     * Is the method preferred ?
     *
     * @qtags.allowed-value true
     * @qtags.allowed-value false
     */
    boolean isPreferred();

}
