package org.xdoclet.plugin.beaninfo.qtags;

/**
 * Defines the JavaBean property found by introspection
 */
public interface JavabeanPropertyTag extends com.thoughtworks.qdox.model.DocletTag {
    /**
     * Name of the property
     *
     */
    String getName_();

    /**
     * The name displayed for the property
     *
     */
    String getDisplayName();

    /**
     * A short description about the property
     *
     */
    String getShortDescription();

    /**
     * Is the property used in expert mode ?
     *
     * @qtags.allowed-value true
     * @qtags.allowed-value false
     */
    boolean isExpert();

    /**
     * Is the property hidden ?
     *
     * @qtags.allowed-value true
     * @qtags.allowed-value false
     */
    boolean isHidden();

    /**
     * Is the property preferred ?
     *
     * @qtags.allowed-value true
     * @qtags.allowed-value false
     */
    boolean isPreferred();

    /**
     * Is this the default property ?
     *
     * @qtags.allowed-value true
     * @qtags.allowed-value false
     */
    boolean isDefault();

    /**
     * Is the property bound ?
     *
     * @qtags.allowed-value true
     * @qtags.allowed-value false
     */
    boolean isBound();

    /**
     * Is the property constrained ?
     *
     * @qtags.allowed-value true
     * @qtags.allowed-value false
     */
    boolean isConstrained();

    /**
     * Fully qualified class name of the PropertyEditor used to edit the property
     *
     */
    String getEditor();

}
