package org.xdoclet.plugin.beaninfo;

import org.generama.MetadataProvider;
import org.generama.Plugin;
import org.generama.VelocityTemplateEngine;
import org.generama.WriterMapper;
import org.xdoclet.AbstractJavaGeneratingPluginTestCase;
import org.xdoclet.QDoxMetadataProvider;

import java.io.File;
import java.net.MalformedURLException;
import java.net.URL;

/**
 * @author Laurent Etiemble
 * @version $Revision: 1.9 $
 */
public class BeanInfoPluginTestCase extends AbstractJavaGeneratingPluginTestCase {
    protected Plugin createPlugin(MetadataProvider metadataProvider, WriterMapper writerMapper) throws Exception {
        BeanInfoPlugin plugin = new BeanInfoPlugin(new VelocityTemplateEngine(), (QDoxMetadataProvider) metadataProvider, writerMapper);
        return plugin;
    }

    protected URL getTestSource() throws MalformedURLException {
        String basedir = System.getProperty("xdoclet.beaninfo.home");
        assertNotNull(basedir);
        return new File(basedir + "/../testapp-pojo/src/main/java/org/xdoclet/testapp/pojo/MyBean.java").toURL();
    }

    protected URL getExpected() throws MalformedURLException {
        String basedir = System.getProperty("xdoclet.beaninfo.home");
        return new File(basedir + "/../plugin-beaninfo/src/test/java/org/xdoclet/testapp/pojo/MyBeanBeanInfo.java").toURL();
    }
}
