package org.xdoclet.testapp.pojo;

import java.awt.Image;
import java.beans.BeanDescriptor;
import java.beans.BeanInfo;
import java.beans.Introspector;
import java.beans.IntrospectionException;
import java.beans.PropertyDescriptor;
import java.beans.ParameterDescriptor;
import java.beans.MethodDescriptor;
import java.beans.SimpleBeanInfo;
import java.beans.PropertyEditorManager;
import java.lang.reflect.Method;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;

/**
 * BeanInfo for org.xdoclet.testapp.pojo.FullOne.
 */
public class MyBeanBeanInfo extends SimpleBeanInfo {
    /* The BeanInfo provided by java.beans.Introspector. */
    private final BeanInfo _introspectedBeanInfo;
    /* The icons map. */
    private Map _icons = null;
    /* Default property. */
    private final String _defaultProperty = "count";
    /* The Bean descriptor. */
    private final BeanDescriptor _beanDescriptor = new BeanDescriptor(org.xdoclet.testapp.pojo.MyBean.class, java.beans.Customizer.class);
    /* Descriptors for methods. */
    private MethodDescriptor[] _methodDescriptors;
    /* Descriptors for properties. */
    private PropertyDescriptor[] _propertyDescriptors;


    public MyBeanBeanInfo() throws java.beans.IntrospectionException {
        // Let the Introspector do the dirty work.
        _introspectedBeanInfo = Introspector.getBeanInfo(org.xdoclet.testapp.pojo.MyBean.class, Introspector.IGNORE_ALL_BEANINFO);

        createPropertyDescriptors();
        try {
            createMethodDescriptors();
        } catch (NoSuchMethodException e) {
            throw new IntrospectionException(e.getMessage());
        }

        try {
            _beanDescriptor.setName("Simple Bean");
            _beanDescriptor.setDisplayName("Very Simple Bean");
            _beanDescriptor.setShortDescription("Simple example of JavaBean BeanInfo generation");
            _beanDescriptor.setExpert(true);
            _beanDescriptor.setPreferred(true);

            _beanDescriptor.setValue("literal", "A sample attribute");
            _beanDescriptor.setValue("expression", new StringBuffer());

            // Set property descriptors from superclass
            BeanInfo info = Introspector.getBeanInfo(getBeanDescriptor().getBeanClass().getSuperclass());
            String order = info.getBeanDescriptor().getValue("propertyorder") == null ? "" : (String) info.getBeanDescriptor().getValue("propertyorder");
            PropertyDescriptor[] pd = getPropertyDescriptors();
            if (pd != null) {
                for (int i = 0; i != pd.length; i++) {
                    if (order.indexOf(pd[i].getName()) == -1) {
                        order = order + (order.length() == 0 ? "" : ":") + pd[i].getName();
                    }
                }
            }
            getBeanDescriptor().setValue("propertyorder", order);
        } catch (Throwable t) {
            t.printStackTrace();
        }
    }

    /**
     * Gets the additional BeanInfo.
     *
     * @return additional BeanInfo.
     */
    public BeanInfo[] getAdditionalBeanInfo() {
        BeanInfo[] result = null;
        return result;
    }

    public Image getIcon(int iconKind) {
        // Lazy loads the icons when needed
        if (_icons == null) {
            _icons = new HashMap(4);
            _icons.put(new Integer(ICON_COLOR_16x16), loadImage("/toolbarButtonGraphics/general/Stop16.gif"));
        }
        return (Image) _icons.get(new Integer(iconKind));
    }

    /**
     * Gets the Bean Descriptor.
     *
     * @return   The Bean Descriptor.
     */
    public BeanDescriptor getBeanDescriptor() {
        return _beanDescriptor;
    }

    /**
     * Gets the default property index if any
     *
     * @return   The default property index
     */
    public int getDefaultPropertyIndex() {
        if (_defaultProperty == null) {
            return -1;
        }
        PropertyDescriptor[] pd = getPropertyDescriptors();
        for (int i = 0; i < pd.length; i++) {
            if (pd[i].getName().equals(_defaultProperty)) {
                return i;
            }
        }
        return -1;
    }

    private void createPropertyDescriptors() {
        // Map the existing property descriptors for easier manipulation.
        Map propertyMap = new HashMap();

        _propertyDescriptors = _introspectedBeanInfo.getPropertyDescriptors();
        for (int i = 0; i < _propertyDescriptors.length; i++) {
            // Set them to hidden. We'll adjust that further down.
            _propertyDescriptors[i].setHidden(true);
            propertyMap.put(_propertyDescriptors[i].getName() + ":" + _propertyDescriptors[i].getPropertyType().getName(), _propertyDescriptors[i]);
        }
        PropertyDescriptor propertyDescriptor = null;

        propertyDescriptor = (PropertyDescriptor) propertyMap.get("content:java.util.Collection");
        propertyDescriptor.setHidden(false);

        propertyDescriptor = (PropertyDescriptor) propertyMap.get("count:int");
        propertyDescriptor.setHidden(false);

        propertyDescriptor = (PropertyDescriptor) propertyMap.get("flag:boolean");
        propertyDescriptor.setHidden(false);

        propertyDescriptor = (PropertyDescriptor) propertyMap.get("name:java.lang.String");
        propertyDescriptor.setHidden(false);
    }

    public PropertyDescriptor[] getPropertyDescriptors() {
        return _propertyDescriptors;
    }

    private void createMethodDescriptors() throws NoSuchMethodException {
        // Map the existing method descriptors for easier manipulation.
        Map methodMap = new HashMap();

        MethodDescriptor[] methodDescriptors = _introspectedBeanInfo.getMethodDescriptors();
        for (int i = 0; i < methodDescriptors.length; i++) {
            // Set them to expert. We'll adjust that further down.
            methodDescriptors[i].setHidden(true);
            methodMap.put(methodDescriptors[i].getMethod(), methodDescriptors[i]);
        }

        Method method = null;
        // The original introspected MethodDescriptor
        MethodDescriptor methodDescriptor = null;
        // The new methodDescriptor
        MethodDescriptor methodDescriptor2 = null;
        // A collection of parameters descriptors
        ArrayList parameterDescriptors = new ArrayList();
        ParameterDescriptor parameterDescriptor;


        method = MyBean.class.getMethod("myFirstMethod", new Class[]{});
        methodDescriptor = (MethodDescriptor) methodMap.get(method);

        // Collect Parameter Descriptors
        parameterDescriptors.clear();

        // Make a new MethodDescriptor with ParameterDescriptors
        methodDescriptor2 = new MethodDescriptor(method, (ParameterDescriptor[]) parameterDescriptors.toArray(new ParameterDescriptor[parameterDescriptors.size()]));
        methodMap.put(method, methodDescriptor2);

        methodDescriptor2.setName(methodDescriptor.getName());
        methodDescriptor2.setDisplayName("My First Method");
        methodDescriptor2.setShortDescription("Example of method without parameters");
        methodDescriptor2.setExpert(methodDescriptor.isExpert());
        methodDescriptor2.setHidden(false);

        methodDescriptor2.setValue("attribute1", "A sample attribute");
        methodDescriptor2.setValue("attribute2", new StringBuffer());

        method = MyBean.class.getMethod("mySecondMethod", new Class[]{java.lang.String.class, Boolean.TYPE, java.util.Collection.class, Short.TYPE});
        methodDescriptor = (MethodDescriptor) methodMap.get(method);

        // Collect Parameter Descriptors
        parameterDescriptors.clear();
        parameterDescriptor = new ParameterDescriptor();
        parameterDescriptor.setName("param1");
        parameterDescriptor.setDisplayName("Parameter 1");
        parameterDescriptor.setShortDescription("Parameter 1 of mySecondMethod");
        parameterDescriptors.add(parameterDescriptor);
        parameterDescriptor = new ParameterDescriptor();
        parameterDescriptor.setName("param2");
        parameterDescriptor.setDisplayName("Parameter 2");
        parameterDescriptor.setShortDescription("Parameter 2 of mySecondMethod");
        parameterDescriptors.add(parameterDescriptor);
        parameterDescriptor = new ParameterDescriptor();
        parameterDescriptor.setName("param3");
        parameterDescriptor.setDisplayName("Parameter 3");
        parameterDescriptor.setShortDescription("Parameter 3 of mySecondMethod");
        parameterDescriptors.add(parameterDescriptor);
        parameterDescriptor = new ParameterDescriptor();
        parameterDescriptor.setName("param4");
        parameterDescriptor.setDisplayName("Parameter 4");
        parameterDescriptor.setShortDescription("Parameter 4 of mySecondMethod");
        parameterDescriptors.add(parameterDescriptor);

        // Make a new MethodDescriptor with ParameterDescriptors
        methodDescriptor2 = new MethodDescriptor(method, (ParameterDescriptor[]) parameterDescriptors.toArray(new ParameterDescriptor[parameterDescriptors.size()]));
        methodMap.put(method, methodDescriptor2);

        methodDescriptor2.setName(methodDescriptor.getName());
        methodDescriptor2.setDisplayName("My Second Method");
        methodDescriptor2.setShortDescription("Example of method with parameters");
        methodDescriptor2.setExpert(methodDescriptor.isExpert());
        methodDescriptor2.setHidden(false);


        List methodList = new ArrayList(methodMap.values());
        _methodDescriptors = (MethodDescriptor[]) methodList.toArray(new MethodDescriptor[methodMap.size()]);
    }

    public MethodDescriptor[] getMethodDescriptors() {
        return _methodDescriptors;
    }
}
