package org.xdoclet.plugin.ejb.descriptor;

import org.generama.WriterMapper;
import org.generama.JellyTemplateEngine;
import org.generama.Plugin;
import org.xdoclet.plugin.ejb.interfaces.LocalInterfacePlugin;
import org.xdoclet.plugin.ejb.interfaces.RemoteInterfacePlugin;
import org.xdoclet.plugin.ejb.EjbUtils;
import org.xdoclet.plugin.ejb.qtags.TagLibrary;
import org.xdoclet.QDoxMetadataProvider;

/**
 * @author Aslak Helles&oslash;y
 * @version $Revision: 1.7 $
 */
public class EjbJarXmlPlugin extends Plugin {
    private EjbUtils ejbUtils;
    private LocalInterfacePlugin localInterfacePlugin;
    private RemoteInterfacePlugin remoteInterfacePlugin;

    public EjbJarXmlPlugin(JellyTemplateEngine jellyTemplateEngine,
            QDoxMetadataProvider metadataProvider,
                           WriterMapper writerMapper,
                           RemoteInterfacePlugin remoteInterfacePlugin,
                           LocalInterfacePlugin localInterfacePlugin
                           ) throws ClassNotFoundException {
        super(jellyTemplateEngine, metadataProvider, writerMapper);

        this.localInterfacePlugin = localInterfacePlugin;
        this.remoteInterfacePlugin = remoteInterfacePlugin;
        ejbUtils = new EjbUtils();

        setFilereplace("ejb-jar.xml");

        setMultioutput(false);

        new TagLibrary(metadataProvider);
    }

    public boolean shouldGenerate(Object metadata) {
        return ejbUtils.shouldGenerate(metadata);
    }

    public EjbUtils getEjbUtils() {
        return ejbUtils;
    }

    public LocalInterfacePlugin getLocalInterfacePlugin() {
        return localInterfacePlugin;
    }

    public RemoteInterfacePlugin getRemoteInterfacePlugin() {
        return remoteInterfacePlugin;
    }
}
