package org.xdoclet.plugin.ejb.interfaces;

import org.generama.WriterMapper;
import org.generama.TemplateEngine;
import org.generama.VelocityTemplateEngine;
import org.generama.defaults.JavaGeneratingPlugin;
import org.generama.velocity.VelocityComponent;
import org.xdoclet.plugin.ejb.EjbUtils;
import org.xdoclet.plugin.ejb.qtags.TagLibrary;
import org.xdoclet.QDoxMetadataProvider;

/**
 *
 * @author Aslak Helles&oslash;y
 * @version $Revision: 1.9 $
 */
public class LocalInterfacePlugin extends JavaGeneratingPlugin {
    private EjbUtils ejbUtils;

    public LocalInterfacePlugin(VelocityTemplateEngine templateEngine, QDoxMetadataProvider metadataProvider, WriterMapper writerMapper) throws ClassNotFoundException {
        super(templateEngine, metadataProvider, writerMapper);
        ejbUtils = new EjbUtils();
        setPackageregex("beans");
        setPackagereplace("interfaces");
        setFileregex("Bean");
        setFilereplace("Local");

        setMultioutput(true);

        new TagLibrary(metadataProvider);
    }

    public boolean shouldGenerate(Object metadata) {
        return ejbUtils.shouldGenerate(metadata);
    }

    public EjbUtils getEjbUtils() {
        return ejbUtils;
    }
}
