package org.xdoclet.plugin.ejb.interfaces;

import org.generama.VelocityTemplateEngine;
import org.generama.WriterMapper;
import org.generama.defaults.JavaGeneratingPlugin;
import org.generama.velocity.VelocityComponent;
import org.xdoclet.QDoxMetadataProvider;
import org.xdoclet.plugin.ejb.EjbUtils;
import org.xdoclet.plugin.ejb.qtags.TagLibrary;

/**
 * @author Aslak Helles&oslash;y
 * @version $Revision: 1.8 $
 */
public class RemoteInterfacePlugin extends JavaGeneratingPlugin {
    private EjbUtils ejbUtils;

    public RemoteInterfacePlugin(VelocityTemplateEngine velocityTemplateEngine, QDoxMetadataProvider metadataProvider, WriterMapper writerMapper) throws ClassNotFoundException {
        super(velocityTemplateEngine, metadataProvider, writerMapper);
        ejbUtils = new EjbUtils();
        setPackageregex("beans");
        setPackagereplace("interfaces");
        setFileregex("Bean");
        setFilereplace("Remote");

        setMultioutput(true);

        new TagLibrary(metadataProvider);
    }

    public boolean shouldGenerate(Object metadata) {
        return ejbUtils.shouldGenerate(metadata);
    }

    public EjbUtils getEjbUtils() {
        return ejbUtils;
    }
}
