package org.xdoclet.plugin.ejb.qtags;

/**
 * Mark a persistent field containing a reference to another entity bean as being
 * aggregated in this bean. The data object will contain accessor methods for the
 * aggregated entity's data object instead of a reference to the entity itself. The
 * aggregated entity will also be removed when this entity is removed. For
 * example, aggregates are useful for sending graphs of data to the client. This is
 * only applicable to entity beans and has no parameters.
 */
public interface EjbAggregateTag extends com.thoughtworks.qdox.model.DocletTag {
}
