package org.xdoclet.plugin.ejb.qtags;

/**
 * Defines an EJB-reference. Applicable to all EJB types. Attention: you have
 * to import the referred class (the ejbdoclet one) even your EJB does not need it.
 * to the bean with EJB-name [ejb-name]. ref-name is optional and if not
 * specified then the reference name is [ejb-name] prefixed by a ejb/
 */
public interface EjbEjbRefTag extends com.thoughtworks.qdox.model.DocletTag {
    /**
     * The name of the EJB being referenced.
     *
     * @qtags.required
     */
    String getEjbName();

    /**
     * The view type that the reference uses.
     *
     * @qtags.required
     * @qtags.allowed-value local
     * @qtags.allowed-value remote
     */
    String getViewType();

    /**
     * The name that the referenced bean will be
     * referred to by. For example, to refer to the bean
     * Customer as java:comp/env/ejb/Customer name
     * should be ejb/Customer. Defaults to
     * ejb/[ejb-name], where [ejb-name] is the named of
     * the referenced bean (Customer) prefixed by
     * "ejb/".
     *
     */
    String getRefName();

}
