package org.xdoclet.plugin.ejb.qtags;

/**
 * Defines an environment entry for an EJB.
 */
public interface EjbEnvEntryTag extends com.thoughtworks.qdox.model.DocletTag {
    /**
     * The name of the env-entry
     *
     * @qtags.required
     */
    String getName_();

    /**
     * Optional description of the env-entry
     *
     */
    String getDescription();

    /**
     * The type of the env-entry, eg
     * java.lang.String. Supported types outlined in
     * the EJB spec.
     * "type" is optional, the default is java.lang.String.
     *
     * @qtags.allowed-value java.lang.Boolean
     * @qtags.allowed-value java.lang.Byte
     * @qtags.allowed-value java.lang.Character
     * @qtags.allowed-value java.lang.String
     * @qtags.allowed-value java.lang.Short
     * @qtags.allowed-value java.lang.Integer
     * @qtags.allowed-value java.lang.Long
     * @qtags.allowed-value java.lang.Float
     * @qtags.allowed-value java.lang.Double
     */
    String getType();

    /**
     * The value of the env-entry
     *
     */
    String getValue_();

}
