package org.xdoclet.plugin.ejb.qtags;

/**
 * Marks session bean method for inclusion in remote facade.
 */
public interface EjbFacadeMethodTag extends com.thoughtworks.qdox.model.DocletTag {
    /**
     * Mark this method as invalidating. Remote Facade will fire
     * callbacks and zap caches. Use on methods which change ejb
     * or create/remove entities. NOTE: setting this to true will have no effect for
     * facade methods which cache their result.
     *
     */
    boolean isInvalidate();

    /**
     * Setup result caching for this method result. No effect on void methods.
     *
     */
    boolean isCache();

    /**
     * If value is immutable it will be never invalidated. No effect on void methods.
     *
     */
    boolean isImmutable();

}
