package org.xdoclet.plugin.ejb.qtags;

/**
 * Defines the transactional behaviour for this method. Applicable to methods
 * with @ejb.create-method and @ejb.interface-method tags. When used on class level applies
 * to all interface methods cumulatively.
 */
public interface EjbPermissionTag extends com.thoughtworks.qdox.model.DocletTag {
    /**
     * Comma-separated list of roles allowed to call this
     * method
     *
     */
    String getRoleName();

    /**
     * Flags the method as having unchecked
     * permission. If present, role-name
     * must be omitted
     *
     */
    boolean isUnchecked();

}
