package org.xdoclet.plugin.ejb.qtags;

/**
 * Defines a relationship between Entity beans.
 */
public interface EjbRelationTag extends com.thoughtworks.qdox.model.DocletTag {
    /**
     * Name of the relation. For bidirectional relationships, specify the same name on both sides.
     *
     * @qtags.required
     */
    String getName_();

    /**
     * Name of the relationship role.
     *
     * @qtags.required
     */
    String getRoleName();

    /**
     * Indicates whether or not the app server should perform cascade deletes. If yes, specify cascade-delete="yes".
     *
     */
    String getCascadeDelete();

    /**
     * Name of the EJB on the other side of the relation. Should *only* occur if the relation is unidirectional.
     *
     */
    String getTargetEjb();

    /**
     * Name of the relationship role on the other side of the relation. Should *only* occur if the relation is unidirectional.
     *
     */
    String getTargetRoleName();

    /**
     * Indicates whether or not the app server should perform cascade deletes for the other side of the relation. If yes, specify cascade-delete="yes". Should *only* occur if the relation is unidirectional.
     *
     */
    String getTargetCascadeDelete();

    /**
     * If this EJB represents a many-side of the other side of the relation, specify target-multiple="yes". If not, just don't use this parameter, or specify "no". Should *only* occur if the relation is unidirectional.
     *
     */
    String getTargetMultiple();

}
