package org.xdoclet.plugin.ejb.qtags;

/**
 * Defines a resource reference with the name res-ref-name to a resource of type
 * res-type, and the authentication is done by the one specified in res-auth.
 */
public interface EjbResourceRefTag extends com.thoughtworks.qdox.model.DocletTag {
    /**
     * The name of the environment entry used in the enterprise bean's code.
     *
     * @qtags.required
     */
    String getResRefName();

    /**
     * The resource type.
     *
     * @qtags.required
     */
    String getResType();

    /**
     * The resource authentication type.
     *
     * @qtags.required
     * @qtags.allowed-value Container
     * @qtags.allowed-value Application
     */
    String getResAuth();

    /**
     * The resource sharing scope
     *
     * @qtags.allowed-value Shareable
     * @qtags.allowed-value Unshareable
     */
    String getResSharingScope();

    /**
     * The physical jndi-name of the resource. Note: it currently is used only in 1-2
     * of the app server modules, but those modules will also support this consolidated standard tag soon.
     *
     */
    String getJndiName();

}
