package org.xdoclet.plugin.ejb.qtags;

/**
 * The security-identity element specifies whether the caller's security
 * identity is to be used for the execution of the methods of the enterprise bean
 * or whether a specific run-as identity is to be used. It contains an optional
 * description and a specification of the security identity to be used.
 */
public interface EjbSecurityIdentityTag extends com.thoughtworks.qdox.model.DocletTag {
    /**
     * The description of the security identity.
     *
     */
    String getDescription();

    /**
     * The use-caller-identity element
     * specifies that the caller's security
     * identity be used as the security identity
     * for the execution of the enterprise
     * bean's methods.
     *
     */
    boolean isUseCallerIdentity();

    /**
     * The run-as element specifies the run-as
     * identity to be used for the execution of
     * the methods of an enterprise bean. It
     * contains an optional description, and the
     * name of a security role.
     *
     */
    String getRunAs();

}
