package org.xdoclet.plugin.ejb.qtags;

/**
 * Defines the transactional behaviour for this method. Applicable to methods
 * with @ejb.create-method and @ejb.interface-method tags.
 * If used on class level applies to all interface methods unless overridden
 */
public interface EjbTransactionTag extends com.thoughtworks.qdox.model.DocletTag {
    /**
     * Define the type of transactional behaviour.
     *
     * @qtags.required
     * @qtags.allowed-value NotSupported
     * @qtags.allowed-value Supports
     * @qtags.allowed-value Required
     * @qtags.allowed-value RequiresNew
     * @qtags.allowed-value Mandatory
     * @qtags.allowed-value Never
     */
    String getType();

}
