package org.xdoclet.plugin.ejb.qtags;

/**
 * This tag is optional, and lets you define whether or not a util class should be
 * generated, and whether to use the logical component name (java:comp/env)
 * or the physical JNDI name to do the lookup. If this tag is not specified, the
 * util class will be generated using logical lookups (provided the <utilobject/>
 * subtask is used)
 */
public interface EjbUtilTag extends com.thoughtworks.qdox.model.DocletTag {
    /**
     * false or no will omit the
     * generation of the util class.
     * logical will generate a util class
     * that uses the component name
     * for lookup, and physical will
     * generate a class that uses the
     * JNDI name for lookups. Default
     * is logical.
     *
     * @qtags.required
     * @qtags.allowed-value false
     * @qtags.allowed-value no
     * @qtags.allowed-value logical
     * @qtags.allowed-value physical
     */
    String getGenerate();

}
