package org.xdoclet.plugin.ejb.qtags;

/**
 * Please write usage description!!!!!
 */
public interface EjbValueObjectTag extends com.thoughtworks.qdox.model.DocletTag {
    /**
     * Repeat here the 'match' attribute declared in a class-level @ejb.value-object
     * tag to link this property to the declared value object.
     *
     */
    String getMatch();

    /**
     * Tell XDoclet which should be the type of items contained in the multi valued
     * property. This should be a fully qualified class name.
     *
     */
    String getCompose();

    /**
     * Tell XDoclet how the accessor methods to this property in the value object
     * should be called. The value of this parameter should be the method name,
     * sans get or set.
     *
     */
    String getComposeName();

    /**
     * Tell XDoclet which should be the type of items contained in the multi valued
     * property. This should be a fully qualified class name.
     *
     */
    String getAggregate();

    /**
     * Tell XDoclet how the accessor methods to this property in the value object
     * should be called. The value of this parameter should be the method name,
     * sans get or set
     *
     */
    String getAggregateName();

    /**
     * The class of the local or remote interface of the associated or composed bean.
     *
     */
    String getMembers();

    /**
     * The Bean Name of the associated or composed Bean.
     *
     */
    String getMembersName();

    /**
     * This tells XDoclet that this property can be updated outside of the scope
     * of this value object, so the generated method should always retrieve the
     * property value. For relations, this is a no brainer: always include the
     * relation="external" parameter.
     *
     */
    String getRelation();

    /**
     * On a multi-valued property, indicates the type of the collection returned
     * by the EJB property accessor. This should be set to 'Collection' or 'Set'
     * in all multi-valued properties.
     *
     * @qtags.allowed-value Collection
     * @qtags.allowed-value Set
     */
    String getType();

}
