package org.xdoclet.plugin.ejb.descriptor;

import org.generama.Plugin;
import org.generama.MetadataProvider;
import org.generama.WriterMapper;
import org.generama.VelocityTemplateEngine;
import org.generama.JellyTemplateEngine;
import org.generama.tests.AbstractXMLGeneratingPluginTestCase;
import org.xdoclet.QDoxMetadataProvider;
import org.xdoclet.plugin.ejb.interfaces.LocalInterfacePlugin;
import org.xdoclet.plugin.ejb.interfaces.RemoteInterfacePlugin;

import java.io.File;
import java.io.IOException;
import java.net.URL;

/**
 *
 * @author Aslak Helles&oslash;y
 * @version $Revision: 1.10 $
 */
public class EjbJarXmlPluginTestCase extends AbstractXMLGeneratingPluginTestCase {
    protected Plugin createPlugin(MetadataProvider metadataProvider, WriterMapper writerMapper) throws Exception {
        VelocityTemplateEngine velocityTemplateEngine = new VelocityTemplateEngine();
        LocalInterfacePlugin localInterfacePlugin = new LocalInterfacePlugin(
                                velocityTemplateEngine,
                                (QDoxMetadataProvider) metadataProvider,
                                writerMapper);
        RemoteInterfacePlugin remoteInterfacePlugin = new RemoteInterfacePlugin(
                                velocityTemplateEngine,
                                (QDoxMetadataProvider) metadataProvider,
                                writerMapper);
        EjbJarXmlPlugin plugin = new EjbJarXmlPlugin(
                new JellyTemplateEngine(),
                (QDoxMetadataProvider) metadataProvider,
                writerMapper,
                remoteInterfacePlugin,
                localInterfacePlugin
        );
        return plugin;
    }

    protected MetadataProvider createMetadataProvider() throws IOException {
        String basedir = System.getProperty("xdoclet.ejb.home");
        assertNotNull(basedir);

        URL reader = new File(basedir + "/../testapp-ejb/src/main/java/org/xdoclet/testapp/ejb/beans/AccountBean.java").toURL();

        return new QDoxMetadataProvider(reader);
    }

    protected URL getExpected() throws IOException {
        return getResourceRelativeToThisPackage("expected/ejb-jar.xml");
    }
}
