package org.xdoclet.plugin.ejb.interfaces;

import org.generama.MetadataProvider;
import org.generama.Plugin;
import org.generama.VelocityTemplateEngine;
import org.generama.WriterMapper;
import org.xdoclet.AbstractJavaGeneratingPluginTestCase;
import org.xdoclet.QDoxMetadataProvider;

import java.io.File;
import java.io.FileNotFoundException;
import java.net.MalformedURLException;
import java.net.URL;

/**
 * @author Aslak Helles&oslash;y
 * @version $Revision: 1.9 $
 */
public class LocalInterfacePluginTestCase extends AbstractJavaGeneratingPluginTestCase {
    protected Plugin createPlugin(MetadataProvider metadataProvider, WriterMapper writerMapper) throws Exception {
        return new LocalInterfacePlugin(new VelocityTemplateEngine(), (QDoxMetadataProvider) metadataProvider, writerMapper);
    }

    protected URL getTestSource() throws FileNotFoundException, MalformedURLException {
        String basedir = System.getProperty("xdoclet.ejb.home");
        assertNotNull(basedir);
        return new File(basedir + "/../testapp-ejb/src/main/java/org/xdoclet/testapp/ejb/beans/AccountBean.java").toURL();
    }

    protected URL getExpected() throws FileNotFoundException, MalformedURLException {
        String basedir = System.getProperty("xdoclet.ejb.home");
        assertNotNull(basedir);
        return new File(basedir + "/../testapp-ejb/src/main/java/org/xdoclet/testapp/ejb/interfaces/AccountLocal.java").toURL();
    }
}
