package org.xdoclet.plugin.externalizer;

import com.thoughtworks.qdox.model.JavaClass;
import org.generama.VelocityTemplateEngine;
import org.generama.WriterMapper;
import org.generama.defaults.JavaGeneratingPlugin;
import org.xdoclet.QDoxMetadataProvider;
import org.xdoclet.plugin.externalizer.qtags.TagLibrary;

public class PropertiesTranslatorPlugin extends JavaGeneratingPlugin {

    public PropertiesTranslatorPlugin(VelocityTemplateEngine velocityTemplateEngine, QDoxMetadataProvider metadataProvider, WriterMapper writerMapper) throws ClassNotFoundException {
        super(velocityTemplateEngine, metadataProvider, writerMapper);
        setFileregex("\\.java");
        setFilereplace("Translator.java");
        setMultioutput(true);
        new TagLibrary(metadataProvider);

    }


    public boolean shouldGenerate(Object metadata) {
        JavaClass clazz = (JavaClass) metadata;
        return clazz.getTagByName("msg.bundle") != null;
    }
}

