package org.xdoclet.plugin.externalizer.test;


import java.text.MessageFormat;

import java.util.MissingResourceException;
import java.util.ResourceBundle;
import java.util.Locale;

public class TestMessagesTranslator {
    public final static String _bundleKey = "org/xdoclet/plugin/externalizer/test/TestMessages";

    public static java.lang.String getString(String resourceKey) {
        try {
            return getBundle().getString(resourceKey.toLowerCase());
        } catch (MissingResourceException ex) {
            return resourceKey;
        }
    }

    public static java.lang.String getString(String resourceKey, Object[] arguments) throws MissingResourceException {
        try {
            return MessageFormat.format(getBundle().getString(resourceKey.toLowerCase()), arguments);
        } catch (MissingResourceException ex) {
            return resourceKey;
        }
    }

    private static ResourceBundle getBundle() throws MissingResourceException {
        return ResourceBundle.getBundle(_bundleKey);
    }

    public static java.lang.String getString(Locale locale, String resourceKey) {
        try {
            return getBundle(locale).getString(resourceKey.toLowerCase());
        } catch (MissingResourceException ex) {
            return resourceKey;
        }
    }

    public static java.lang.String getString(Locale locale, String resourceKey, Object[] arguments) throws MissingResourceException {
        try {
            return MessageFormat.format(getBundle(locale).getString(resourceKey.toLowerCase()), arguments);
        } catch (MissingResourceException ex) {
            return resourceKey;
        }
    }

    private static ResourceBundle getBundle(Locale locale) throws MissingResourceException {
        return ResourceBundle.getBundle(_bundleKey);
    }


}
