/*
 * Copyright (c) 2003
 * XDoclet Team
 * All rights reserved.
 */
package org.xdoclet.plugin.hibernate.qtags;


/**
 * @qtags.location class
 */
public interface HibernateArrayTag extends com.thoughtworks.qdox.model.DocletTag {
    /**
     * Specifies which operations should be cascaded from the parent object to the associated object
     *
     * @qtags.allowed-value all
     * @qtags.allowed-value none
     * @qtags.allowed-value save-update
     * @qtags.allowed-value delete
     */
    String getCascade();

    /**
     * The name of a table schema to override the schema declared
     *
     */
    String getSchema();

    /**
     * The name of the collection table (not used for one-to-many associations)
     *
     */
    String getTable();

    /**
     * An SQL WHERE condition
     *
     */
    String getWhere();
}
