/*
 * Copyright (c) 2003
 * XDoclet Team
 * All rights reserved.
 */
package org.xdoclet.plugin.hibernate.qtags;

import org.xdoclet.plugin.hibernate.qtags.parameter.Name;
import org.xdoclet.plugin.hibernate.qtags.parameter.Lazy;
import org.xdoclet.plugin.hibernate.qtags.parameter.BatchSize;
import org.xdoclet.plugin.hibernate.qtags.parameter.DiscriminatorValue;
import org.xdoclet.plugin.hibernate.qtags.parameter.DynamicInsert;
import org.xdoclet.plugin.hibernate.qtags.parameter.DynamicUpdate;
import org.xdoclet.plugin.hibernate.qtags.parameter.Proxy;
import org.xdoclet.plugin.hibernate.qtags.parameter.Schema;
import org.xdoclet.plugin.hibernate.qtags.parameter.Table;
import org.xdoclet.plugin.hibernate.qtags.parameter.Where;

/**
 * Declare a persistent class
 * @qtags.location class
 * @qtags.once
 */
public interface HibernateClassTag extends com.thoughtworks.qdox.model.DocletTag,
        Lazy, BatchSize, DiscriminatorValue, DynamicInsert, DynamicUpdate, Proxy, Schema,
        Table, Where, Name {


    /**
     * Specifies that instances of the class are (not) mutable
     */
    Boolean isMutable();

    /**
     *
     * @qtags.allowed-value none
     * @qtags.allowed-value dirty
     * @qtags.allowed-value version
     * @qtags.allowed-value all
     */
    String getOptimisticLock();

    /**
     * persister definition
     */
    String getPersister();

    /**
     * Enable "explicit" polymorphism
     *
     * @qtags.allowed-value explicit
     * @qtags.allowed-value implicit
     */
    String getPolymorphism();


    Boolean getSelectBeforeUpdate();


}
