/*
 * Copyright (c) 2003
 * XDoclet Team
 * All rights reserved.
 */
package org.xdoclet.plugin.hibernate.qtags;

import org.xdoclet.plugin.hibernate.qtags.parameter.Index;
import org.xdoclet.plugin.hibernate.qtags.parameter.Length;
import org.xdoclet.plugin.hibernate.qtags.parameter.NotNull;
import org.xdoclet.plugin.hibernate.qtags.parameter.SqlType;
import org.xdoclet.plugin.hibernate.qtags.parameter.Unique;

// Derived classes have the same property / parameter set.
// but since column must be spoecified in several situations ( and for the same property )
// it's necessary to split.

/**
 * Customize column mapping.
 * @qtags.location method
 */
public interface HibernateColumn
        extends com.thoughtworks.qdox.model.DocletTag, Index, Length, NotNull,
        SqlType, Unique {

    /**
     * The column name
     *
     * @qtags.required
     */
    String getName_();

    /**
     * The name of a unique constraint
     */
    String getUniqueKey();
}
