/*
 * Copyright (c) 2003
 * XDoclet Team
 * All rights reserved.
 */
package org.xdoclet.plugin.hibernate.qtags;

import org.xdoclet.plugin.hibernate.qtags.parameter.Length;
import org.xdoclet.plugin.hibernate.qtags.parameter.Type;
import org.xdoclet.plugin.hibernate.qtags.parameter.NotNull;

/**
 * Defines a discriminator. Polymorphic data requires a column holding a class discriminator value. This
 * value is not directly exposed to the application. 
 * @qtags.location class
 */
public interface HibernateDiscriminatorTag
        extends com.thoughtworks.qdox.model.DocletTag, Length, Type, NotNull {
    /**
     * The name of the mapped database table column
     *
     * @qtags.default class
     */
    String getColumn();

    /**
     * do not know what it means. 
     */
    Boolean getForce();
}
