/*
 * Copyright (c) 2003
 * XDoclet Team
 * All rights reserved.
 */
package org.xdoclet.plugin.hibernate;

import net.sf.hibernate.util.DTDEntityResolver;
import org.custommonkey.xmlunit.XMLUnit;
import org.generama.JellyTemplateEngine;
import org.generama.MetadataProvider;
import org.generama.Plugin;
import org.generama.WriterMapper;
import org.generama.tests.AbstractXMLGeneratingPluginTestCase;
import org.xml.sax.EntityResolver;

/**
 * Abstract test case for all hibernate mapping testing. We create plugin here, and also
 * setup entity resolver for xmlunit parsers. We take entity resolver from hibernate,
 * so we can always be sure that we got correct DTD.
 *
 * @author Konstantin Pribluda ( konstantin.pribluda(at)infodesire.com )
 */
public abstract class AbstractHibernateMappingTestCase extends AbstractXMLGeneratingPluginTestCase {

    protected void setUp() throws Exception {
        super.setUp();

        XMLUnit.getControlDocumentBuilderFactory().setValidating(true);
        XMLUnit.getTestDocumentBuilderFactory().setValidating(true);
        EntityResolver entityResolver = new DTDEntityResolver();
        expectedParser.setEntityResolver(entityResolver);
        actualParser.setEntityResolver(entityResolver);
    }

    protected Plugin createPlugin(MetadataProvider metadataProvider,
                                  WriterMapper writerMapper) {
        return new HibernateMappingPlugin(new JellyTemplateEngine(), metadataProvider, writerMapper);
    }
}
