/*
 * Copyright (c) 2003
 * XDoclet Team
 * All rights reserved.
 */
package org.xdoclet.plugin.hibernate.pojo;

import java.util.List;

/**
 * test pojo to test primitive properties and ID
 * 
 * @hibernate.class table="bag-table"
 */
public class BagMapping {
    private List _bag;

    /**
     * test one-to-many set
     * 
     * @hibernate.jcs-cache usage="read-only"
     * @hibernate.meta attribute="foo" value="bar"
     * @hibernate.meta attribute="bar" inherit="false" value="blurge"
     * @hibernate.bag table="blurge" schema="baz" lazy="true" inverse="false"
     *                cascade="all" order-by="foo" where="bar" outer-join="auto"
     * @hibernate.key column="foo" foreign-key="bar"
     * @hibernate.one-to-many class="org.xdoclet.plugin.hibernate.pojo.Simple"
     */
    public List getOneToMany() {
        return _bag;
    }

    public void setOneTopMany(List bag) {
        _bag = bag;
    }

    /**
     * test one-to-many set with multiple key
     * 
     * @hibernate.bag table="blurge"
     * @hibernate.key
     * @hibernate.key-column name="column1"
     * @hibernate.key-column name="column2"
     * @hibernate.one-to-many class="org.xdoclet.plugin.hibernate.pojo.Simple"
     */
    public List getOneToManyWithMultipleKey() {
        return _bag;
    }

    public void setOneTopManyWithMultipleKey(List bag) {
        _bag = bag;
    }

    /**
     * test element set
     * 
     * @hibernate.bag order-by="blurge" inverse="true"
     * @hibernate.element type="string"
     */
    public List getElement() {
        return _bag;
    }

    public void setElement(List bag) {
        _bag = bag;
    }

}