/*
 * Copyright (c) 2003
 * XDoclet Team
 * All rights reserved.
 */
package org.xdoclet.plugin.hibernate.pojo;

import java.util.List;

/**
 * test pojo to test list mappings
 * 
 * @hibernate.class table="bag-table"
 */
public class ListMapping {
    private List _list;

    /**
     * test one-to-many set
     * 
     * @hibernate.jcs-cache usage="read-only"
     * @hibernate.meta attribute="foo" value="bar"
     * @hibernate.meta attribute="bar" inherit="false" value="blurge"
     * @hibernate.list table="blurge" schema="baz" lazy="true" inverse="false"
     *                 cascade="all" order-by="foo" where="bar"
     *                 outer-join="auto"
     * @hibernate.key column="foo" foreign-key="bar"
     * @hibernate.index
     * @hibernate.one-to-many class="org.xdoclet.plugin.hibernate.pojo.Simple"
     */
    public List getOneToMany() {
        return _list;
    }

    public void setOneTopMany(List list) {
        _list = list;
    }

    /**
     * test element set
     * 
     * @hibernate.list order-by="blurge"
     * @hibernate.index
     * @hibernate.element type="string"
     */
    public List getElement() {
        return _list;
    }

    public void setElement(List list) {
        _list = list;
    }

    /**
     * @hibernate.list
     * @hibernate.index
     * @hibernate.key
     * @hibernate.key-column name="column1"
     * @hibernate.key-column name="column2"
     * @hibernate.many-to-many class="org.xdoclet.plugin.hibernate.pojo.Simple"
     */
    public List getManyToManyWithMultipleKey() {
        return _list;
    }

    public void setManyToManyWithMultipleKey(List list) {
        _list = list;
    }

    /**
     * @hibernate.list
     * @hibernate.index
     * @hibernate.many-to-many class="org.xdoclet.plugin.hibernate.pojo.Simple"
     */

    public List getManyToMany() {
        return _list;
    }

    public void setManyToMany(List list) {
        _list = list;
    }
}