/*
 * Copyright (c) 2003
 * XDoclet Team
 * All rights reserved.
 */
package org.xdoclet.plugin.hibernate.pojo;


/**
 * test pojo to test  relations
 * @author konstantin pribluda ( kpriblouda(at)yahoo.com )
 * @hibernate.class
 */
public class Relation {
    private Simple _oneSide;
    private long _id;
    private Simple _oneToOne;

    public void setId(long id) {
        _id = id;
    }

    /**
     * @hibernate.id unsaved-value="blurge" generator-class="native"
     */
    public long getId() {
        return _id;
    }

    /**
     * @hibernate.many-to-one cascade="none" not-null="true" column="aclid"
     *      class="com.infodesire.infobit.dao.AclImpl"
     */
    public Simple getOneSide() {
        return _oneSide;
    }

    public void setOneSide(Simple oneSide) {
        _oneSide = oneSide;
    }

    /**
     * @hibernate.many-to-one class="com.infodesire.infobit.dao.AclImpl"
     * @hibernate.column name="one"
     * @hibernate.column name="two"
     */
    public Simple getOneSideWithMutipleKeys() {
        return _oneSide;
    }

    public void setOneSideWithMutipleKeys(Simple oneSide) {
        _oneSide = oneSide;
    }

    /**
     * @hibernate.one-to-one constrained="false"
     */
    public Simple getOneToOne() {
        return _oneToOne;
    }

    public void setOneToOne(Simple oneToOne) {
        _oneToOne = oneToOne;
    }
}
