/*
 * Copyright (c) 2003
 * XDoclet Team
 * All rights reserved.
 */
package org.xdoclet.plugin.hibernate.pojo;

import java.util.Set;

/**
 * test pojo to test primitive properties and ID
 * 
 * @hibernate.class table="set-table"
 */
public class SetMapping {
    private Set _set;

    /**
     * test one-to-many set
     * 
     * @hibernate.jcs-cache usage="read-only"
     * @hibernate.meta attribute="foo" value="bar"
     * @hibernate.meta attribute="bar" inherit="false" value="blurge"
     * @hibernate.set table="blurge" schema="baz" lazy="true" inverse="false"
     *                sort="blabla" cascade="all" order-by="foo" where="bar"
     *                outer-join="auto"
     * @hibernate.key column="foo" foreign-key="bar"
     * @hibernate.one-to-many class="org.xdoclet.plugin.hibernate.pojo.Simple"
     */
    public Set getOneToMany() {
        return _set;
    }

    public void setOneTopMany(Set set) {
        _set = set;
    }

    /**
     * test one-to-many set using multiple key-column
     * 
     * @hibernate.set table="blurge"
     * @hibernate.key
     * @hibernate.key-column name="column1"
     * @hibernate.key-column name="column2"
     * @hibernate.one-to-many class="org.xdoclet.plugin.hibernate.pojo.Simple"
     */
    public Set getOneToManyWithMultipleKey() {
        return _set;
    }

    public void setOneToManyWithMultipleKey(Set set) {
        _set = set;
    }

    /**
     * test element set
     * 
     * @hibernate.set order-by="blurge"
     * @hibernate.element type="string"
     */
    public Set getElement() {
        return _set;
    }

    public void setElement(Set set) {
        _set = set;
    }
}