/*
 * Copyright (c) 2003
 * XDoclet Team
 * All rights reserved.
 */
package org.xdoclet.plugin.hibernate.pojo;

/**
 * test pojo to test primitive properties and ID
 * 
 * @hibernate.class table="simple-table" schema="schema" proxy="foo.bar.baz"
 *                  discriminator-value="blurge" mutable="false"
 *                  polymorphism="explicit" where="bla bla" persister="goo"
 *                  dynamic-update="true" dynamic-insert="false"
 *                  batch-size="239" select-before-update="true"
 *                  optimistic-lock="version" lazy="true"
 */
public class Simple {
    private Object _fullBlown;
    private String _name;
    private long _id;

    /**
     * property defined on field level
     * 
     * @hibernate.property index="blam"
     */
    private int blurge;

    public void setFullBlown(Object fullBlown) {
        _fullBlown = fullBlown;
    }

    /**
     * fully blown property. shall generate all the elements
     * 
     * @hibernate.property column="foo-bar" length="235" not-null="true"
     *                     unique="true" insert="false" update="false"
     *                     type="baz.bang.blurge" formula="gee"
     */
    public Object getFullBlown() {
        return _fullBlown;
    }

    public void setId(long id) {
        _id = id;
    }

    /**
     * @hibernate.id unsaved-value="yahoo" generator-class="native"
     * @hibernate.column name="blurge" sql-type="foobar"
     * @hibernate.meta attribute="attribute" inherit="true" value="blurge"
     */
    public long getId() {
        return _id;
    }

    void setName(String name) {
        _name = name;
    }

    /**
     * just default property, shall generate just name
     * 
     * @hibernate.property
     */
    public String getName() {
        return _name;
    }
}