package org.xdoclet.plugin.jmx;

import com.thoughtworks.qdox.model.DocletTag;
import com.thoughtworks.qdox.model.JavaClass;
import org.generama.VelocityTemplateEngine;
import org.generama.WriterMapper;
import org.generama.defaults.JavaGeneratingPlugin;
import org.xdoclet.QDoxMetadataProvider;
import org.xdoclet.plugin.jmx.qtags.TagLibrary;

/**
 * @author Laurent Etiemble
 * @version $Revision: 1.5 $
 */
public class MBeanPlugin extends JavaGeneratingPlugin {

    public MBeanPlugin(VelocityTemplateEngine velocityTemplateEngine, QDoxMetadataProvider metadataProvider, WriterMapper writerMapper) {
        super(velocityTemplateEngine, metadataProvider, writerMapper);

        // Add a suffix to the filename
        setFileregex("\\.java");
        setFilereplace("MBean.java");

        // Generate one file per scanned java source
        setMultioutput(true);

        // Register the tags used by this plugin
        new TagLibrary(metadataProvider);
    }

    public boolean shouldGenerate(Object metadata) {
        JavaClass javaClass = (JavaClass) metadata;
        DocletTag javaBeanTag = javaClass.getTagByName("jmx.mbean");
        return (javaBeanTag != null);
    }
}