package org.xdoclet.plugin.jmx;

import org.generama.WriterMapper;
import org.generama.VelocityTemplateEngine;

import org.generama.defaults.JavaGeneratingPlugin;

import org.generama.velocity.VelocityComponent;

import org.xdoclet.QDoxMetadataProvider;

import org.xdoclet.plugin.jmx.qtags.TagLibrary;



import com.thoughtworks.qdox.model.DocletTag;

import com.thoughtworks.qdox.model.JavaClass;

/**
 * @author   Laurent Etiemble
 * @version  $Revision: 1.5 $
 */
public class MLetPlugin extends JavaGeneratingPlugin {

    public MLetPlugin(VelocityTemplateEngine velocityTemplateEngine, QDoxMetadataProvider metadataProvider, WriterMapper writerMapper) {
        super(velocityTemplateEngine, metadataProvider, writerMapper);

        // Add a suffix to the filename
        setFilereplace("mbeans.mlet");

        // Generate only one file from all the scanned java sources
        setMultioutput(false);

        // Register the tags used by this plugin
        new TagLibrary(metadataProvider);
    }


	public boolean shouldGenerate(Object metadata) {
		JavaClass javaClass = (JavaClass) metadata;
		DocletTag javaBeanTag = javaClass.getTagByName("jmx.mlet-entry");
		return (javaBeanTag != null);
	}
}