package org.xdoclet.plugin.jmx.qtags;

/**
 * Defines a jmx managed operation.  This method will be included in a
 * standard mbean interface and marked as a managed operation in xmbean metadata.
 * jmx.managed-parameter tags must be used to describe the parameters.
 */
public interface JmxManagedOperationTag extends com.thoughtworks.qdox.model.DocletTag {
    /**
     * Specifies the impact of the operation.
     *
     * @qtags.allowed-value ACTION
     * @qtags.allowed-value INFO
     * @qtags.allowed-value ACTION_INFO
     */
    String getImpact();

    /**
     * Specifies a description for the managed operation that can be used in mbean infos.
     *
     */
    String getDescription();

}
