package org.xdoclet.plugin.jmx.qtags;

/**
 * Defines an argument for a managed operation or managed constructor.
 * NOTE: this tag is somewhat defective in that some of the info (type) can be
 * determined automatically and there is no check that the number of parameters
 * or their types specified actually match the method.  You should expect the
 * usage of this tag to change without notice.
 */
public interface JmxManagedParameterTag extends com.thoughtworks.qdox.model.DocletTag {
    /**
     * Specifies a name for the operation or constructor argument. This can be different from the name used in java code.
     *
     * @qtags.required
     */
    String getName_();

    /**
     * Specifies a description for the operation or constructor argument.
     *
     */
    String getDescription();

    /**
     * The type of the argument.  This should be determined from the method signature.
     *
     * @qtags.required
     */
    String getType();

    /**
     * A string representation of the value for the managed argument.  Only useful for constructor arguments.
     *
     */
    String getValue_();

}
