package org.xdoclet.plugin.jmx.qtags;

/**
 * Defines a jmx notification.
 */
public interface JmxNotificationTag extends com.thoughtworks.qdox.model.DocletTag {
    /**
     * Specifies the description for the notification.
     *
     */
    String getDescription();

    /**
     * Specifies the name for the notification.
     *
     * @qtags.required
     */
    String getName_();

    /**
     * Specifies the persistence policy for this mbean
     *
     * @qtags.allowed-value OnUpdate
     * @qtags.allowed-value NoMoreOftenThan
     * @qtags.allowed-value Never
     * @qtags.allowed-value OnTimer
     */
    String getPersistPolicy();

    /**
     * Specifies when the mbean state will be saved. Not sure how this applies to notifications.
     *
     */
    String getPersistPeriod();

    /**
     * Specifies the location for the mbean's state to be saved. Not sure how this applies to notifications.
     *
     */
    String getPersistLocation();

    /**
     * Specifies the name to identify the mbeans saved state with. Not sure how this applies to notifications.
     *
     */
    String getPersistName();

    /**
     * Specifies how long the mbeans state may be considered valid. Not sure how this applies to notifications.
     *
     */
    String getCurrencyTimeLimit();

    /**
     * Specifies an additional custom descriptor for the mbean that can be used in mbean infos.
     * This should be of the form name="name" value="value".  To make this work as an xdoclet
     * parameter, you need to escape the double quotes: descriptor="name=\"name\" value=\"value\""
     *
     */
    String getDescriptor();

}
