package org.xdoclet.plugin.jmx;

import org.generama.MetadataProvider;
import org.generama.Plugin;
import org.generama.VelocityTemplateEngine;
import org.generama.WriterMapper;
import org.xdoclet.AbstractJavaGeneratingPluginTestCase;
import org.xdoclet.QDoxMetadataProvider;

import java.io.File;
import java.io.FileNotFoundException;
import java.net.MalformedURLException;
import java.net.URL;

/**
 * @author Laurent Etiemble
 * @version $Revision: 1.4 $
 */
public class MBeanPluginTestCase extends AbstractJavaGeneratingPluginTestCase {

    protected Plugin createPlugin(MetadataProvider metadataProvider, WriterMapper writerMapper) throws Exception {
        return new MBeanPlugin(new VelocityTemplateEngine(), (QDoxMetadataProvider) metadataProvider, writerMapper);
    }

    protected URL getTestSource() throws FileNotFoundException, MalformedURLException {
        String basedir = System.getProperty("xdoclet.jmx.home");
        assertNotNull(basedir);
        return new File(basedir + "/../plugin-jmx/src/test/java/org/xdoclet/testapp/pojo/ThingManagement.java").toURL();
    }

    protected URL getExpected() throws FileNotFoundException, MalformedURLException {
        String basedir = System.getProperty("xdoclet.jmx.home");
        return new File(basedir + "/../plugin-jmx/src/test/java/org/xdoclet/testapp/pojo/ThingManagementMBean.java").toURL();
    }
}
