package org.xdoclet.plugin.jmx;

import org.generama.MetadataProvider;
import org.generama.Plugin;
import org.generama.VelocityTemplateEngine;
import org.generama.WriterMapper;
import org.generama.tests.AbstractTextGeneratingPluginTestCase;
import org.xdoclet.QDoxMetadataProvider;

import java.io.File;
import java.io.FileNotFoundException;
import java.net.MalformedURLException;
import java.net.URL;

/**
 * @author Laurent Etiemble
 * @version $Revision: 1.4 $
 */
public class MLetPluginTestCase extends AbstractTextGeneratingPluginTestCase {

    protected Plugin createPlugin(MetadataProvider metadataProvider, WriterMapper writerMapper) throws Exception {
        return new MLetPlugin(new VelocityTemplateEngine(), (QDoxMetadataProvider) metadataProvider, writerMapper);
    }

    protected MetadataProvider createMetadataProvider() throws Exception {
        String basedir = System.getProperty("xdoclet.jmx.home");
        assertNotNull(basedir);
        File testAppDir = new File(basedir, "../plugin-jmx/src/test/java/org/xdoclet/testapp/pojo");
        return new QDoxMetadataProvider(testAppDir);
    }

    protected URL getExpected() throws FileNotFoundException, MalformedURLException {
        String basedir = System.getProperty("xdoclet.jmx.home");
        return new File(basedir + "/../plugin-jmx/src/test/java/org/xdoclet/plugin/jmx/expected/mbeans.mlet").toURL();
    }

}

