package org.xdoclet.plugin.junit;

import com.thoughtworks.qdox.model.JavaClass;
import org.generama.VelocityTemplateEngine;
import org.generama.WriterMapper;
import org.generama.defaults.JavaGeneratingPlugin;
import org.xdoclet.QDoxMetadataProvider;

/**
 * Generates one TestSuite class for a number of test classes.
 *
 * @author Aslak Helles&oslash;y
 * @version $Revision: 1.3 $
 */
public class TestSuitePlugin extends JavaGeneratingPlugin {
    private String name = "GeneratedTestSuite";

    public TestSuitePlugin(VelocityTemplateEngine velocityTemplateEngine, QDoxMetadataProvider metadataProvider, WriterMapper writerMapper) {
        super(velocityTemplateEngine, metadataProvider, writerMapper);
        setMultioutput(false);
        setFilereplace("AllTests.java");
    }

    public boolean shouldGenerate(Object metadata) {
        JavaClass clazz = (JavaClass) metadata;
        return clazz.isA("junit.framework.Test") && clazz.isPublic() && !clazz.isAbstract();
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }
}
