package org.xdoclet.plugin.junit;

import org.generama.MetadataProvider;
import org.generama.Plugin;
import org.generama.VelocityTemplateEngine;
import org.generama.WriterMapper;
import org.xdoclet.AbstractJavaGeneratingPluginTestCase;
import org.xdoclet.QDoxMetadataProvider;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;

public class TestSuitePluginTestCase extends AbstractJavaGeneratingPluginTestCase {
    protected Plugin createPlugin(MetadataProvider metadataProvider, WriterMapper writerMapper) throws Exception {
        final TestSuitePlugin testSuitePlugin = new TestSuitePlugin(new VelocityTemplateEngine(), (QDoxMetadataProvider) metadataProvider, writerMapper);
        testSuitePlugin.setPackagereplace("some.pack");
        testSuitePlugin.setName("SomeName");
        return testSuitePlugin;
    }

    protected MetadataProvider createMetadataProvider() throws IOException {
        String basedir = System.getProperty("xdoclet.junit.home");
        assertNotNull(basedir);

        return new QDoxMetadataProvider(new File(basedir + "/src/test/java"));
    }

    protected URL getExpected() throws FileNotFoundException, MalformedURLException {
        String basedir = System.getProperty("xdoclet.junit.home");
        assertNotNull(basedir);

        return new File(basedir + "/src/test/testdata/some/pack/AllTests.java").toURL();
    }

}
