package org.xdoclet.plugin.plugin;

import org.generama.MetadataProvider;
import org.generama.Plugin;
import org.generama.VelocityTemplateEngine;
import org.generama.WriterMapper;
import org.generama.tests.AbstractTextGeneratingPluginTestCase;
import org.xdoclet.QDoxMetadataProvider;

import java.io.File;
import java.io.IOException;
import java.net.URL;

public class PluginPluginTestCase extends AbstractTextGeneratingPluginTestCase {
    protected Plugin createPlugin(MetadataProvider metadataProvider, WriterMapper writerMapper) throws Exception {
        return new PluginPlugin(new VelocityTemplateEngine(), (QDoxMetadataProvider) metadataProvider, writerMapper);
    }

    protected MetadataProvider createMetadataProvider() throws IOException {
        String basedir = System.getProperty("xdoclet.plugin.home");
        assertNotNull(basedir);
        URL reader = new File(basedir + "/src/main/java/org/xdoclet/plugin/plugin/PluginPlugin.java").toURL();
        return new QDoxMetadataProvider(reader);
    }

    protected URL getExpected() throws IOException {
        return getResourceRelativeToThisPackage("expected/PluginPlugin.confluence");
    }

}
