package org.xdoclet.plugin.portlet.qtags;

import com.thoughtworks.qdox.model.DocletTag;

/**
 * Defines mime-type support for the portlet.
 */
public interface PortletPreferencesTag extends DocletTag {
  /**
   * The preference name.
   *
   * @qtags.required
   */
  String getName_();
  
  /**
   * The preference's default value;
   *
   * @qtags.required
   */
  String getValue_();
  
  /**
   * Specifies that the preference is read-only. Defaults to false.
   * 
   * @qtags.allowed-value true
   * @qtags.allowed-value false
   */
  String getReadOnly();
}
