package org.xdoclet.plugin.portlet.qtags;

import com.thoughtworks.qdox.model.DocletTag;

/**
 * Defines mime-type support for the portlet.
 */
public interface PortletSupportsTag extends DocletTag {
  /**
   * Mime-type supported by the portlet.
   *
   * @qtags.required
   */
  String getMimeType();
  
  /**
   * Comma-separated list of modes supported for the specified mime-type.
   * 
   * @qtags.required
   */
  String getModes();
}
