package org.xdoclet.plugin.portlet;


import org.generama.JellyTemplateEngine;
import org.generama.MetadataProvider;
import org.generama.Plugin;
import org.generama.WriterMapper;
import org.generama.tests.AbstractXMLGeneratingPluginTestCase;
import org.xdoclet.QDoxMetadataProvider;

import java.io.File;
import java.io.IOException;
import java.net.URL;

public class PortletXmlPluginTestCase extends AbstractXMLGeneratingPluginTestCase {
    protected Plugin createPlugin(MetadataProvider metadataProvider, WriterMapper writerMapper) throws Exception {
        return new PortletXmlPlugin(new JellyTemplateEngine(), (QDoxMetadataProvider) metadataProvider, writerMapper);
    }

    protected MetadataProvider createMetadataProvider() throws IOException {
        String basedir = System.getProperty("xdoclet.portlet.home");
        assertNotNull(basedir);
        File testAppDir = new File(basedir, "../testapp-portlet/src/main/java/org/xdoclet/testapp/portlet");
        return new QDoxMetadataProvider(testAppDir);
    }

    protected URL getExpected() throws IOException {
        return getResourceRelativeToThisPackage("../../testapp/portlet/expected/portlet.xml");
    }
}