package org.xdoclet.plugin.qtags.impl;

import com.thoughtworks.qdox.model.DocletTag;
import com.thoughtworks.qdox.model.JavaClass;
import org.generama.VelocityTemplateEngine;
import org.generama.WriterMapper;
import org.generama.MetadataProvider;
import org.generama.defaults.JavaGeneratingPlugin;
import org.xdoclet.QDoxMetadataProvider;
import org.xdoclet.plugin.qtags.QTagUtils;

/**
 * @author Aslak Helles&oslash;y
 * @author Konstantin Pribluda
 * @version $Revision: 1.10 $
 */
public class QTagImplPlugin extends JavaGeneratingPlugin {
    private QTagUtils qTagUtils = new QTagUtils();

    public QTagImplPlugin(VelocityTemplateEngine velocityTemplateEngine, MetadataProvider metadataProvider,
                          WriterMapper writerMapper) {
        super(velocityTemplateEngine, metadataProvider, writerMapper);

        setFileregex("\\.java");
        setFilereplace("Impl.java");
        setMultioutput(true);

        qTagUtils.registerLibrary((QDoxMetadataProvider)metadataProvider);
    }

    public boolean shouldGenerate(Object metadata) {
        return qTagUtils.shouldGenerate(metadata);
    }

    public QTagUtils getQTagUtils() {
        return qTagUtils;
    }


}
