package org.xdoclet.plugin.qtags.confluence;

import org.generama.MetadataProvider;
import org.generama.Plugin;
import org.generama.VelocityTemplateEngine;
import org.generama.WriterMapper;
import org.generama.tests.AbstractTextGeneratingPluginTestCase;
import org.xdoclet.QDoxMetadataProvider;

import java.io.IOException;
import java.net.URL;

/**
 *
 * @author Aslak Helles&oslash;y
 * @version $Revision: 1.2 $
 */
public class QTagConfluencePluginTestCase extends AbstractTextGeneratingPluginTestCase {
    protected Plugin createPlugin(MetadataProvider metadataProvider,
                                          WriterMapper writerMapper) throws Exception {
        QTagConfluencePlugin result = new QTagConfluencePlugin(new VelocityTemplateEngine(), (QDoxMetadataProvider)metadataProvider, writerMapper);
        result.setNamespace("foo");
        return result;
    }

    protected MetadataProvider createMetadataProvider() throws IOException {
        URL reader = getResourceRelativeToThisPackage("../impl/test/FooBarTag.java");
        return new QDoxMetadataProvider(reader);
    }

    protected URL getExpected() throws IOException {
        return getResourceURLRelativeToThisPackage("expected/FooBar.confluence");
    }
}
