package org.xdoclet.plugin.qtags.xdoc;

import org.generama.JellyTemplateEngine;
import org.generama.MetadataProvider;
import org.generama.Plugin;
import org.generama.WriterMapper;
import org.generama.tests.AbstractXMLGeneratingPluginTestCase;
import org.xdoclet.QDoxMetadataProvider;

import java.io.IOException;
import java.net.URL;

/**
 *
 * @author Aslak Helles&oslash;y
 * @version $Revision: 1.11 $
 */
public class QTagXDocPluginTestCase extends AbstractXMLGeneratingPluginTestCase {
    protected Plugin createPlugin(MetadataProvider metadataProvider,
                                          WriterMapper writerMapper) throws Exception {
        QTagXDocPlugin result = new QTagXDocPlugin(new JellyTemplateEngine(), metadataProvider,
                writerMapper);

        result.setNamespace("foo");
        return result;
    }

    protected MetadataProvider createMetadataProvider()
            throws IOException {
        URL reader = getResourceRelativeToThisPackage("../impl/test/FooBarTag.java");

        return new QDoxMetadataProvider(reader);
    }

    protected URL getExpected() throws IOException {
        return getResourceRelativeToThisPackage("expected/FooBar.xml");
    }
}
