package org.xdoclet.plugin.web.qtags;

/**
 * Declares the specified field a JSP tag
 * attribute. This tag should be placed on getter methods
 */
public interface JspAttributeTag extends com.thoughtworks.qdox.model.DocletTag {
    /**
     * Whether the attribute is required. If not specified, the container
     * will assume this attribute is not required.
     *
     */
    boolean isRequired();

    /**
     * Whether the attribute is a runtime attribute. If not specified, the
     * container will assume this attribute can only take static values (ie
     * rtexprvalue=false)
     *
     */
    boolean isRtexprvalue();

    /**
     * The type of the attribute.
     */
    String getType();

    /**
     * An optional description of the attribute.
     *
     */
    String getDescription();

}
