package org.xdoclet.plugin.web.qtags;

/**
 * Declares the class as a class implementing a
 * JSP tag and specifies various properties of that tag
 */
public interface JspTagTag extends com.thoughtworks.qdox.model.DocletTag {
    /**
     * The name of the JSP tag.
     *
     * @qtags.required
     */
    String getName_();

    /**
     * The tei class for the JSP.
     *
     */
    String getTeiClass();

    /**
     * The body content field for the tag.  "JSP" | "empty" | "tagdependent"
     *
     * @qtags.allowed-value tagdependent
     * @qtags.allowed-value JSP
     * @qtags.allowed-value empty
     * @qtags.default JSP
     */
    String getBodyContent();

    /**
     * An optional display name for the tag
     *
     */
    String getDisplayName();

    /**
     * An optional small icon for the tag
     *
     */
    String getSmallIcon();

    /**
     * An optional large icon for the tag
     *
     */
    String getLargeIcon();

    /**
     * An optional description for the tag
     *
     */
    String getDescription();

}
