package org.xdoclet.plugin.web.qtags;

/**
 * Declares a JSP tag variable and information
 * on the scripting variables defined.
 */
public interface JspVariableTag extends com.thoughtworks.qdox.model.DocletTag {
    /**
     * The variable name as a constant
     *
     */
    String getNameGiven();

    /**
     * The name of an attribute whose
     * (translation time) value will give the name of the variable.
     * One of name-given or name-from-attribute is required
     *
     */
    String getNameFromAttribute();

    /**
     * Name of the class of the variable.
     * java.lang.String is default
     *
     * @qtags.default java.lang.String
     */
    String getClass_();

    /**
     * Whether the variable is declared or not.
     *
     * @qtags.default true
     */
    boolean isDeclare();

    /**
     * The scope of the scripting variable defined."NESTED" | "AT_BEGIN" | "AT_END"
     *
     * @qtags.allowed-value NESTED
     * @qtags.allowed-value AT_BEGIN
     * @qtags.allowed-value AT_END
     * @qtags.default NESTED
     */
    String getScope();

    /**
     * An optional description of the variable
     *
     */
    String getDescription();

}
