package org.xdoclet.plugin.web.qtags;

/**
 * Defines a local EJB reference with the
 * specified name, type, home interface name, local interface name,
 * link name, and description. The value of the link parameter must
 * be the ejb-name of an enterprise bean in the same J2EE
 * application unit.
 */
public interface WebEjbLocalRefTag extends com.thoughtworks.qdox.model.DocletTag {
    /**
     * The name or the ejb reference
     *
     */
    String getName_();

    /**
     * The expected type of the referenced
     * enterprise bean. Must be one of the following: Entity or Session
     *
     * @qtags.allowed-value Entity
     * @qtags.allowed-value Session
     */
    String getType();

    /**
     * The home interface of the referenced ejb
     *
     */
    String getHome();

    /**
     * The local interface of the referenced ejb
     *
     */
    String getLocal();

    /**
     * The link to the EJB
     *
     */
    String getLink();

    /**
     * An optional description for the ejb-ref
     *
     */
    String getDescription();

}
