package org.xdoclet.plugin.web.qtags;

/**
 * Declares the class as a Filter class, with
 * the specified name, display-name, icon and description.
 * Applicable to Servlet 2.3 only
 */
public interface WebFilterTag extends com.thoughtworks.qdox.model.DocletTag {
    /**
     * The name for the filter. Unique within the application
     *
     * @qtags.required
     */
    String getName_();

    /**
     * The display name of the filter
     *
     */
    String getDisplayName();

    /**
     * The icon for the filter
     *
     */
    String getIcon();

    /**
     * A description for the filter
     *
     */
    String getDescription();

    String getOrder();
}
