package org.xdoclet.plugin.web.qtags;

/**
 * Defines a resource reference with the
 * specified name, type, description, authentication (auth) and scope
 */
public interface WebResourceRefTag extends com.thoughtworks.qdox.model.DocletTag {
    /**
     * The name of the resource reference
     *
     * @qtags.required
     */
    String getName_();

    /**
     * The type of the referenced resource
     *
     * @qtags.required
     */
    String getType();

    /**
     * The authentication for the resource.  "Application" | "Container"
     *
     * @qtags.required
     * @qtags.allowed-value Application
     * @qtags.allowed-value Container
     */
    String getAuth();

    /**
     * An optional description for the resource reference
     *
     */
    String getDescription();

    /**
     * The scope of the resource.  "Shareable" | "Unshareable"
     *
     * @qtags.allowed-value Shareable
     * @qtags.allowed-value Unshareable
     */
    String getScope();

    /**
     * The physical jndi-name of the resource. Note: it currently is used only in 1-2
     * of the app server modules, but those modules will also support this consolidated standard tag soon.
     *
     */
    String getJndiName();

}
