package org.xdoclet.plugin.web.qtags;

/**
 * Declares the class as a Servlet class, with
 * the specified name, display-name, icon and description
 */
public interface WebServletTag extends com.thoughtworks.qdox.model.DocletTag {
    /**
     * The name of the servlet - unique within the application
     *
     * @qtags.required
     */
    String getName_();

    /**
     * The display name of the servlet
     *
     */
    String getDisplayName();

    /**
     * The icon for the servlet
     *
     */
    String getIcon();

    /**
     * A description for the servlet
     *
     */
    String getDescription();

    /**
     * Integer indicating order in which the servlet should be loaded.
     *
     */
    String getLoadOnStartup();

    /**
     * Specifies the run-as identity (the name of
     * a security role) to be used for the execution of the web
     * application.
     *
     */
    String getRunAs();

}
