package org.xdoclet.plugin.web;

import junit.framework.TestCase;
import com.thoughtworks.qdox.JavaDocBuilder;

import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

/**
 * An abstract test case class that makes it easier to load inner class
 * source code.
 * Use the builder class member to load class sources.
 *
 *
 * <p><br/><br/>created     Oct 27, 2003 1:17:55 AM</p>
 * @author     gjoseph
 * @author     $Author: rinkrank $ (last edit)
 * @version    $Revision: 1.2 $
 */
public abstract class AbstractCodeReadingTestCase extends TestCase {
    protected JavaDocBuilder builder;

    public void setUp() throws IOException {
        String className = this.getClass().getName();
        String shortClName = className.substring(className.lastIndexOf('.') + 1, className.length());
        String sourceFileName = shortClName + ".java";
        InputStream res = this.getClass().getResourceAsStream(sourceFileName);
        assertNotNull(res);
        builder = new JavaDocBuilder();
        builder.addSource(new InputStreamReader(res));
    }
}
