package org.xdoclet.plugin.web;

import com.thoughtworks.qdox.model.JavaClass;
import org.apache.commons.collections.Predicate;

import java.io.IOException;

/**
 * This tests the ClassTagPredicate predicate.
 * TODO : maybe this makes the FakeFilters etc tests redundant.
 *
 * @author <a href="mailto:greg_greg@freestart.hu">Grgory Joseph</a>
 * @author $Author: moinsmoins $ (last edit)
 * @version $Revision: 1.4 $
 */
public class ClassTagPredicateTestCase extends AbstractCodeReadingTestCase {

    public void testPredicate() throws IOException {
        Predicate p = new ClassTagPredicate("org.xdoclet.plugin.web.ClassTagPredicateTestCase$DummyInterface", "dummytag");

        JavaClass cl = builder.getClassByName("org.xdoclet.plugin.web.ClassTagPredicateTestCase$DummyClass");
        assertNotNull(cl);
        assertTrue(p.evaluate(cl));
        cl = builder.getClassByName("org.xdoclet.plugin.web.ClassTagPredicateTestCase$DummyInterface");
        assertFalse(p.evaluate(cl));
        cl = builder.getClassByName("org.xdoclet.plugin.web.ClassTagPredicateTestCase$AbstractDummyClass");
        assertFalse(p.evaluate(cl));
        cl = builder.getClassByName("org.xdoclet.plugin.web.ClassTagPredicateTestCase$FakeDummyClass");
        assertFalse(p.evaluate(cl));
        cl = builder.getClassByName("org.xdoclet.plugin.web.ClassTagPredicateTestCase$TaglessDummyClass");
        assertFalse(p.evaluate(cl));
    }

    // ------ dummy classes for the purpose of this test
    /**
     * @dummytag
     */
    public interface DummyInterface {
        public void dummy();
    }

    /**
     * @dummytag
     */
    public abstract class AbstractDummyClass implements DummyInterface {
        public String dummierThanDummy() {
            return "Vocal Talent: Bill Thompson (Touche Turtle), Alan Reed (Dum Dum).";
        }
    }

    /**
     * @dummytag
     */
    public class DummyClass implements DummyInterface {
        public void dummy() {
            System.out.println("Dum Dum (Touche Turtle's dimwitted sidekick)");
        }
    }

    /**
     * @dummytag
     * tagged but not implementing
     */
    public class FakeDummyClass {
        public void dummiest() {
            System.out.println("Naaa I won't implement dummy!");
        }
    }

    /**
     * no tags for this one
     */
    public class TaglessDummyClass implements DummyInterface {
        public void dummy() {
            System.out.println("Brandishing his trusty sword Touche Turtle and his simpleminded assistant Dum Dum, he heroically saves queens, maidens and others in distress.");
        }
    }
}

