package org.xdoclet.plugin.web;

import org.generama.MetadataProvider;
import org.generama.Plugin;
import org.generama.WriterMapper;
import org.generama.JellyTemplateEngine;
import org.generama.tests.AbstractXMLGeneratingPluginTestCase;
import org.xdoclet.QDoxMetadataProvider;

import java.io.File;
import java.io.IOException;
import java.net.URL;

/**
 * @author Gr&eacute;gory Joseph(moins_moins)
 * @author $Author: rinkrank $ (last edit)
 * @version $Revision: 1.10 $
 */
public class TaglibPluginTestCase extends AbstractXMLGeneratingPluginTestCase {

    protected void setUp() throws Exception {
        super.setUp();
        registerDtd(TaglibPlugin.PUBLIC_ID_1_2, getResourceURLRelativeToThisPackage("web-jsptaglibrary_1_2.dtd"));
    }

    protected Plugin createPlugin(MetadataProvider metadataProvider, WriterMapper writerMapper) throws Exception {
        return new TaglibPlugin(new JellyTemplateEngine(), (QDoxMetadataProvider) metadataProvider, writerMapper);
    }

    protected MetadataProvider createMetadataProvider() throws IOException {
        String basedir = System.getProperty("xdoclet.web.home");
        assertNotNull(basedir);
        File testAppDir = new File(basedir, "../testapp-web/src/main/java/org/xdoclet/testapp/web");
        return new QDoxMetadataProvider(testAppDir);
    }

    protected URL getExpected() throws IOException {
        return getResourceRelativeToThisPackage("../../testapp/web/expected/taglib.tld");
    }

}
