package org.xdoclet.plugin.webwork;

import org.generama.VelocityTemplateEngine;

import org.generama.WriterMapper;
import org.generama.Plugin;
import org.xdoclet.QDoxMetadataProvider;
import org.xdoclet.plugin.webwork.qtags.TagLibrary;
import org.generama.velocity.VelocityComponent;

import com.thoughtworks.qdox.model.JavaClass;

public class ViewsPropertiesPlugin extends Plugin {

	String destinationFileName = "views.properties";
	String mergeFile = null;
    public ViewsPropertiesPlugin(VelocityTemplateEngine velocityTemplateEngine, QDoxMetadataProvider metadataProvider,
                                 WriterMapper writerMapper) {
        super(velocityTemplateEngine, metadataProvider, writerMapper);
        setMultioutput(false);

        new TagLibrary(metadataProvider);
    }

    /**
     * determine whether this metadata is interesting ( has to be webwork.action.Action ,
     * has to be class, got to have webwork.action tag, and must be concrete )
     */
    public boolean shouldGenerate(Object metadata) {
        JavaClass clazz = (JavaClass) metadata;

        return !clazz.isInterface() &&
                !clazz.isAbstract() &&
                clazz.isA("webwork.action.Action") &&
                clazz.getTagsByName("webwork.action", true).length > 0;
    }

	public String getDestinationFilename(Object metadata) {
		return destinationFileName;
	}
	
	
	public void setDestinationFilename(String name) {
		destinationFileName = name;
	}
    
    /**
    * name of merge file to be used. no merge if not specified.
    * directory containing merge file shall be made available in classpath
    */
    public String getMergefile() {
        return mergeFile;
    }
    
    public void setMergefile(String name) {
        mergeFile = name;
    }
}