/*
 * Copyright (c) 2003
 * XDoclet Team
 * All rights reserved.
 */
package org.xdoclet.plugin.webwork;

import org.generama.MetadataProvider;
import org.generama.Plugin;
import org.generama.VelocityTemplateEngine;
import org.generama.WriterMapper;
import org.generama.tests.AbstractPropertyGeneratingPluginTestCase;
import org.xdoclet.QDoxMetadataProvider;

import java.io.IOException;
import java.net.URL;

public class ViewsPropertiesPluginTestCase extends AbstractPropertyGeneratingPluginTestCase {

    protected URL getExpected() throws Exception {
        return getResourceRelativeToThisPackage("action/views.properties");
    }

    protected MetadataProvider createMetadataProvider()
            throws IOException {
        URL reader = getResourceRelativeToThisPackage("action/TestAction.java");
        return new QDoxMetadataProvider(reader);
    }

    protected Plugin createPlugin(MetadataProvider metadataProvider,
                                          WriterMapper writerMapper) throws Exception {
        return new ViewsPropertiesPlugin(new VelocityTemplateEngine(), (QDoxMetadataProvider) metadataProvider,
                writerMapper);
    }
}