package org.xdoclet.sampleapp.web;

import java.util.Date;
import java.util.TreeSet;

/**
 * A simple "guest book" object used in xdoclet's web plugin.
 *
 *
 * <p><br/><br/>created     Nov 1, 2003 5:40:44 PM</p>
 * @author     <a href="mailto:greg_greg@freestart.hu">Gr&eacute;gory Joseph</a>
 * @author     $Author: moinsmoins $ (last edit)
 * @version    $Revision: 1.1 $
 */
public class Guestbook {
    private Date initDate;
    private TreeSet messages;

    public Guestbook() {
        this.initDate = new Date();
        messages = new TreeSet();
    }

    public void addMessage(String name, String message) {
        GuestbookEntry entry = new GuestbookEntry(name, message);
        messages.add(entry);
    }

    public GuestbookEntry[] getAllMessages() {
        return (GuestbookEntry[]) messages.toArray(new GuestbookEntry[messages.size()]);
    }

    public Date getInitDate() {
        return this.initDate;
    }

    protected class GuestbookEntry implements Comparable {
        private Date date;
        private String name;
        private String message;

        public GuestbookEntry(String name, String message) {
            this.date = new Date();
            this.name = name;
            this.message = message;
        }

        public Date getDate() {
            return date;
        }

        public String getMessage() {
            return message;
        }

        public String getName() {
            return name;
        }

        // we don't need to implement a compareTo which is smart enough to avoid
        // ClassCastExceptions since it will only be internally used by Guestbook
        public int compareTo(Object o) {
            GuestbookEntry entry = (GuestbookEntry) o;
            return this.date.compareTo(entry.getDate());
        }
    }

}
