package org.xdoclet.sampleapp.web;

import org.xdoclet.sampleapp.web.Guestbook;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.ServletException;
import java.io.IOException;

/**
 * The main servlet for the guestbook. The POST method is used to add messages
 * and the GET method to simpy display the book.
 *
 * TODO : validate and remove html or other potentially dangerous content
 * from name and message.
 *
 * @web.servlet
 *     display-name="Guestbook Servlet"
 *     name="GuestbookServlet"
 *     description="This is a servlet used to display and add messages to the Guestbook."
 * @web.servlet-mapping
 *     url-pattern="/gbook"
 *
 *
 * @author     <a href="mailto:greg_greg@freestart.hu">Gr&eacute;gory Joseph</a>
 * @author     $Author: moinsmoins $ (last edit)
 * @version    $Revision: 1.1 $
 */
public class GuestbookServlet extends HttpServlet {
    protected void doPost(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
        String name = req.getParameter("gbook.name");
        String message = req.getParameter("gbook.message");
        Guestbook gbook = (Guestbook) getServletContext().getAttribute("xdoclet.web.gbook");
        if (gbook == null) {
            throw new ServletException("The Guestbook object was not initialized.");
        }
        gbook.addMessage(name, message);

        req.getRequestDispatcher("WEB-INF/jsp/gbook.jsp").include(req, res);
    }

    protected void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
        req.getRequestDispatcher("WEB-INF/jsp/gbook.jsp").include(req, res);
    }


}
