package org.xdoclet.sampleapp.web;

import org.xdoclet.sampleapp.web.Guestbook;

import javax.servlet.jsp.tagext.TagSupport;
import javax.servlet.jsp.JspException;
import java.text.DateFormat;
import java.util.Locale;

/**
 * A tag that will expose variables of a guestbook object stored in the
 * servlet context, and will expose the guestbook object to inner tags.
 *
 * @jsp.tag name="gbook"
 *          display-name="GuestbookTag"
 *          body-content="JSP"
 *          description="Tag exposing a guestbook, with the help of an inner GuestbookEntryTag."
 *          tei-class="org.xdoclet.sampleapp.web.GuestbookTagTEI"
 *
 * @author     <a href="mailto:greg_greg@freestart.hu">Gr&eacute;gory Joseph</a>
 * @author     $Author: moinsmoins $ (last edit)
 * @version    $Revision: 1.1 $
 */
public class GuestbookTag extends TagSupport {
    private DateFormat df = DateFormat.getDateTimeInstance(DateFormat.MEDIUM, DateFormat.SHORT, Locale.getDefault());
    private Guestbook gbook;

    public int doStartTag() throws JspException {
        this.gbook = (Guestbook) pageContext.getServletContext().getAttribute("xdoclet.web.gbook");

        String formattedDate =  df.format(gbook.getInitDate());
        pageContext.setAttribute("initDate", formattedDate);

        return EVAL_BODY_INCLUDE;
    }

    public Guestbook.GuestbookEntry[] getAllMessages() {
        return gbook.getAllMessages();
    }

}
