package org.xdoclet.sampleapp.web;

import javax.servlet.Filter;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.FilterChain;
import javax.servlet.ServletException;
import javax.servlet.FilterConfig;
import java.io.IOException;

/**
 * A simple filter that includes header.inc.jsp and footer.inc.jsp as header
 * and footer of the page.
 *
 * @web.filter
 *     display-name="Layout Filter"
 *     name="LayoutFilter"
 *     order="9"
 *
 * @web.filter-mapping
 *     servlet-name="GuestbookServlet"
 *
 * @author     <a href="mailto:greg_greg@freestart.hu">Gr&eacute;gory Joseph</a>
 * @author     $Author: moinsmoins $ (last edit)
 * @version    $Revision: 1.1 $
 */
public class LayoutFilter implements Filter {

    public void doFilter(ServletRequest req, ServletResponse res, FilterChain filterChain) throws IOException, ServletException {
        req.getRequestDispatcher("WEB-INF/jsp/header.inc.jsp").include(req, res);
        filterChain.doFilter(req, res);
        req.getRequestDispatcher("WEB-INF/jsp/footer.inc.jsp").include(req, res);
    }

    public void init(FilterConfig filterConfig) throws ServletException {
    }

    public void destroy() {
    }

}
