package org.xdoclet.testapp.ejb.beans;

import org.xdoclet.testapp.ejb.interfaces.NoNumberException;

import javax.ejb.EntityBean;

import java.util.Collection;

/**
 * This is part of the common test application for all ejb-related
 * XDoclet plugin. Vendor-specific tags should be added herein.
 *
 * @author Aslak Helles&oslash;y
 * @version $Revision: 1.5 $
 */
public abstract class AccountBean implements EntityBean {
    /**
     * @ejb.interface-method view-type="local"
     * @return Collection of {@link OwnerLocal}
     */
    public abstract Collection getOwners();

    /**
     * @ejb.interface-method view-type="both"
     * @return the account number
     */
    public abstract String getNumber()
            throws NoNumberException;

    /**
     * @ejb.interface-method view-type="both"
     * @return the account type
     */
    public abstract String getType();
}
