package org.xdoclet.testapp.pojo;

import java.util.Date;
import java.util.Set;

/**
 * @author Administrator
 *
 * @hibernate.class
 *  table="ANIMALS"
 *  dynamic-update="true"
 *  dynamic-insert="false"
 */
public class Animal {
    private Set prey;
    private char sex;
    private Long id;
    private int version;
    private Date created;

    /**
     * Constructor for Animal.
     */
    public Animal() {
        super();
    }

    /**
     * @hibernate.id
     *  unsaved-value="null"
     *  generator-class="sequence"
     * @hibernate.generator-param
     *  name="table"
     *  value="HIVAL"
     * @hibernate.generator-param
     *  name="column"
     *  value="NEXT"
     * @return Long
     */
    public Long getId() {
        return id;
    }

    /**
     * Sets the id.
     * @param id The id to set
     */
    public void setId(Long id) {
        this.id = id;
    }

    /**
     * @hibernate.version
     * @return int
     */
    public int getVersion() {
        return version;
    }

    /**
     * Sets the version.
     * @param version The version to set
     */
    public void setVersion(int version) {
        this.version = version;
    }

    /**
     * @hibernate.property
     *  update="false"
     *  insert="true"
     *  type="timestamp"
     * @return Date
     */
    public Date getCreated() {
        return created;
    }

    /**
     * Sets the created.
     * @param created The created to set
     */
    public void setCreated(Date created) {
        this.created = created;
    }

    /**
     * @hibernate.set
     *  lazy="true"
     *  table="PREDATOR_PREY"
     *  order-by="PREY_ID"
     * @hibernate.collection-key
     *  column="PREDATOR_ID"
     * @hibernate.collection-many-to-many
     *  column="PREY_ID"
     * @return Set
     */
    public Set getPrey() {
        return prey;
    }

    /**
     * Sets the prey.
     * @param prey The prey to set
     */
    public void setPrey(Set prey) {
        this.prey = prey;
    }

    /**
     * Returns the sex.
     * @hibernate.property
     *  not-null="true"
     * @return char
     */
    public char getSex() {
        return sex;
    }

    /**
     * Sets the sex.
     * @param sex The sex to set
     */
    public void setSex(char sex) {
        this.sex = sex;
    }
}
