package org.xdoclet.testapp.portlet;

import java.io.IOException;
import javax.portlet.GenericPortlet;
import javax.portlet.PortletException;
import javax.portlet.RenderRequest;
import javax.portlet.RenderResponse;

/**
 * @portlet.portlet
 *     name="TestPortlet"
 *     display-name="Test"
 *     description="Test Portlet for XDoclet"
 *     expiration-cache="3600"
 * 
 * @portlet.supports
 *     mime-type="text/html"
 *     modes="EDIT,HELP"
 * 
 * @portlet.supports
 *     mime-type="text/vnd.wap.wml"
 *     modes="HELP"
 * 
 * @portlet.portlet-init-param
 *     name="testParam1"
 *     value="ABC"
 * 
 * @portlet.portlet-init-param
 *     name="testParam2"
 *     value="123"
 * 
 * @portlet.preference
 *     name="testPreference1"
 *     value="FOO"
 * 
 * @portlet.preference
 *     name="testPreference2"
 *     value="BAR"
 * 
 * @portlet.preferences-validator
 *     validator-class="org.xdoclet.plugins.portlet.TestPortletPreferencesValidator"
 * 
 * @portlet.portlet-info
 *     title="Test title"
 *     short-title="Test short title"
 *     keywords="Test keywords"
 * 
 * @portlet.locale locale="en_US"
 * @portlet.locale locale="es_MX"
 * 
 * @portlet.resource-bundle bundle="testBundle"
 */
public class TestPortlet extends GenericPortlet {
    protected void doView(RenderRequest request, RenderResponse response)
            throws PortletException, IOException {

        response.getWriter().write("Test Portlet");
    }
}